<?php

// If required and available duplicate post function
if (file_exists(dirname(__file__) . '/duplicate.php')) {
    require_once( dirname(__file__) . '/duplicate.php' );
}


// If required and available custom meta box
if (file_exists(dirname(__file__) . '/custom-meta-box/custom-meta-box.php')) {

    if ( ! function_exists( 'book_an_appointment_961_init_custom_box_place' ) ) {
        function book_an_appointment_961_init_custom_box_place() {
        
            require_once( dirname(__file__) . '/custom-meta-box/custom-meta-box.php' );
            $config = array(
                    'id'     => 'custom_meta_box',
                    // 'context'  => 'normal',            
                    // 'priority' => 'high',    
                    // 'meta_key' => 'custom',
                    'title'  => __('Place properties', 'book-an-appointment'),
                    'pages'  => array('booking-place'),         // array('post', 'page')
                    'fields' => array() 
                );
                
            $custom_meta_box = new Dovi42_Appointment_Meta_Box($config);    
           /*
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'on_days',
                            'type'  => 'checkbox',
                            'label' => __('Allow booking on business days.', 'book-an-appointment'),
                        ));
            */
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'days_on_week',
                            'type'  => 'checkboxs',
                            'label' => __('Possible days', 'book-an-appointment'),
                            'checks' => array(
                                    'mon' => __('Monday', 'book-an-appointment'),
                                    'tue' => __('Tuesday', 'book-an-appointment'),
                                    'wed' => __('Wednesday', 'book-an-appointment'),
                                    'thu' => __('Thursday', 'book-an-appointment'),
                                    'fri' => __('Friday', 'book-an-appointment'),
                                    'sat' => __('Saturday', 'book-an-appointment'),
                                    'sun' => __('Sunday ', 'book-an-appointment')
                                ),
                        ));
            /*
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'on_weekends',
                            'type'  => 'checkbox',
                            'label' => __('Allow booking on weekends.', 'book-an-appointment'),
                        ));
            */
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'on_holidays',
                            'type'  => 'checkbox',
                            'label' => __('Allow booking on public holidays.', 'book-an-appointment'),
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'reservation',
                            'type'   => 'radio',
                            'label'  => __('Reservation type:', 'book-an-appointment'),
                            'values' => array(
                                'day'   => __('Full day', 'book-an-appointment'),
                                'time'  => __('Time point', 'book-an-appointment')
                            )
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'mins',
                            'type'  => 'number',
                            'label' => __('Minute period:', 'book-an-appointment'),
                            'description' => __('Minute in one reservation.', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'reserved',
                            'type'   => 'text',
                            'label' => __('Reserved times:', 'book-an-appointment'),
                            'description' => __('Taken times separated by commas. <small><em>(eg 12:00,12:30)</em></small>', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'disabled',
                            'type'   => 'textarea',
                            'label' => __('Disabled days:', 'book-an-appointment'),
                            'description' => __('Days that cannot be booked.<br />Taken dates separated by commas. <small><em>(eg 2020-09-21,2020-09-22)</em></small>', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'enabled',
                            'type'   => 'textarea',
                            'label' => __('Enabled days:', 'book-an-appointment'),
                            'description' => __('Days to which you can take a date.<br />Taken dates separated by commas. <small><em>(eg 2020-09-21,2020-09-22)</em></small>', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'shift',
                            'type'  => 'number',
                            'label' => __('Shift hour(s):', 'book-an-appointment'),
                            'description' => __('You can book no earlier than this many hours.', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'    => 'future',
                            'type'  => 'number',
                            'label' => __('Later day(s):', 'book-an-appointment'),
                            'description' => __('Up to the day specified here can be booked later.', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'emails',
                            'type'   => 'text',
                            'label' => __('Notifications:', 'book-an-appointment'),
                            'description' => __('Sends a notification of confirmed bookings to these recipients.<br /><small>Comma-separated email address list. If left blank, no notification will be sent.</small>', 'book-an-appointment')
                        ));

            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'sep',
                            'type'   => 'label',
                            'label' => __('Manager(s) in frontend', 'book-an-appointment'),
                            'description' => __('Users configured here can see, confirm, or cancel reservations on the frontend.', 'book-an-appointment')
                        ));
            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'sep2',
                            'type'   => 'separator'
                        ));

            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'managers',
                            'type'   => 'usergroups',
                            'mode'   => 'checkbox',
                            'label' => __('Manager groups:', 'book-an-appointment'),
                            'description' => __('Select manager(s) in group lists.', 'book-an-appointment')
                        ));

            $custom_meta_box
                ->addField(
                        array(
                            'id'     => 'manager',
                            'type'   => 'userlist',
                            'label' => __('Manage user:', 'book-an-appointment'),
                            'description' => __('Select user for managed in frontend.', 'book-an-appointment')
                        ));

            /* *******************  Calendar box ******************* */ 
            
            $options = book_an_appointment_961_refresh_calendar_token();
            
            if (!empty($options['calendar']['code'])) {
                
                if (!class_exists('GoogleCalendarApi')) {
                    include_once( BOOK_AN_APPOINTMENT_961_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'google-calendar-api.php');
                }
                $capi = new GoogleCalendarApi();
                $list = $capi->GetCalendarsList($options['calendar']['token']);

                $values = array('' => __('--== Not useed! ==--', 'book-an-appointment'));
                if (!empty($list)) {
                    foreach ($list as $item) {
                        $values[$item['id']] = $item['summary'];
                    } 
                }
                    
                $config = array(
                        'id'     => 'calendar_meta_box',
                        'context'  => 'side',            
                        'priority' => 'default',    
                        // 'meta_key' => 'custom',
                        'title'  => __('Select calendar in Google', 'book-an-appointment'),
                        'pages'  => array('booking-place'),         // array('post', 'page')
                        'fields' => array() 
                    );
                $calendar_meta_box = new Dovi42_Appointment_Meta_Box($config); 
                $calendar_meta_box
                    ->addField(
                            array(
                                'id'     => 'calendar',
                                'type'   => 'select',
                                'label'  => __('', 'book-an-apointment'),
                                'values' => $values)
                            );
            }


            $config = array(
                    'id'     => 'holiday_meta_box',
                    'context'  => 'side',            
                    'priority' => 'default',    
                    // 'meta_key' => 'custom',
                    'title'  => __('Holidays and weekend', 'book-an-appointment'),
                    'pages'  => array('booking-place'),         // array('post', 'page')
                    'fields' => array() 
                );
                

            $holidays_meta_box = new Dovi42_Appointment_Meta_Box($config);    
            $holidays_meta_box
                ->addField(
                        array(
                            'id'    => 'holiday_on_time',
                            'type'  => 'time',
                            'label' => __('On time:', 'book-an-appointment'),
                        ));
            $holidays_meta_box
                ->addField(
                        array(
                            'id'    => 'holiday_off_time',
                            'type'  => 'time',
                            'label' => __('Off time:', 'book-an-appointment'),
                        ));



            $config = array(
                    'id'     => 'couple_meta_box',
                    'context'  => 'side',            
                    'priority' => 'default',    
                    // 'meta_key' => 'custom',
                    'title'  => __('In a couple of weeks', 'book-an-appointment'),
                    'pages'  => array('booking-place'),         // array('post', 'page')
                    'fields' => array() 
                );
                

            $couple_meta_box = new Dovi42_Appointment_Meta_Box($config);    
            $couple_meta_box
                ->addField(
                        array(
                            'id'    => 'couple_on_time',
                            'type'  => 'time',
                            'label' => __('On time:', 'book-an-appointment'),
                        ));
            $couple_meta_box
                ->addField(
                        array(
                            'id'    => 'couple_off_time',
                            'type'  => 'time',
                            'label' => __('Off time:', 'book-an-appointment'),
                        ));

            $config['id'] = 'odd_meta_box';
            $config['title'] = __('An odd weeks', 'book-an-appointment');
            $odd_meta_box = new Dovi42_Appointment_Meta_Box($config);    
            $odd_meta_box
                ->addField(
                        array(
                            'id'    => 'odd_on_time',
                            'type'  => 'time',
                            'label' => __('On time:', 'book-an-appointment'),
                        ));
            $odd_meta_box
                ->addField(
                        array(
                            'id'    => 'odd_off_time',
                            'type'  => 'time',
                            'label' => __('Off time:', 'book-an-appointment'),
                        ));
            
                        
        }
        add_action( 'plugins_loaded', 'book_an_appointment_961_init_custom_box_place' );
    }
}