<?php
if (!class_exists('JDovi42_Templates')) {
    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_templates.php');
}

function book_an_appointment_961_render_month_table($month, $id, $times) {
    
    global $wpdb;
    
    $options = book_an_appointment_961_get_options();
    // $html = '<table data-month="'.$month.'"><caption>'.date_i18n($options['date_format'], strtotime($month.'-01')).'</caption>'.'<thead><tr>';
    
    $empty_day   = apply_filters('book_an_appointment_empty_day', null);
    $week_before = apply_filters('book_an_appointment_week_before', null);
    $week_after  = apply_filters('book_an_appointment_week_after', null);
    
    
    $html = apply_filters('book_an_appointment_month_table_before', $month);
    
    $daylist = array();
    $start_of_week = get_option( 'start_of_week' );
    $days = array(
        __('Su', 'book-an-appointment'),
        __('Mo', 'book-an-appointment'),
        __('Tu', 'book-an-appointment'),
        __('We', 'book-an-appointment'),
        __('Th', 'book-an-appointment'),
        __('Fr', 'book-an-appointment'),
        __('Sa', 'book-an-appointment'));
    for ($i = $start_of_week; $i <= 6; $i++) {
    	$daylist[] = __($days[$i]);
    }
    for ($i = 0; $i < $start_of_week; $i++) {
    	$daylist[] = __($days[$i]);
    }
    $html .= apply_filters('book_an_appointment_month_table_header', $daylist);
    $html .= $week_before;

    $col = 1;
    $first = date('N', strtotime($month.'-01'));
    $days = date('t', strtotime($month.'-01'));
    for ($i = 0; $i < ($first - $start_of_week); $i++) {
    	$html .= $empty_day;
        $col++;
    }

    $shift = get_post_meta($id, 'appointment_shift', true);
    if ($shift == '0') { $shift = ''; }
    if (!empty($shift)) {
        $end_time = date_i18n('Y-m-d H:i:s', strtotime('+'.$shift.' hours')); 
        $now = date_i18n('Y-m-d', strtotime('+'.$shift.' hours'));
        
    } else {
        $now = date_i18n('Y-m-d');
    }
    
    $on_works    = get_post_meta($id, 'appointment_on_days', true);
    $on_holidays = get_post_meta($id, 'appointment_on_holidays', true);
    $on_disabled = get_post_meta($id, 'appointment_disabled', true);
    $on_disabled = str_replace(' ', '', $on_disabled);
    $on_disabled = explode(',', $on_disabled);

    $on_enabled = get_post_meta($id, 'appointment_enabled', true);
    $on_enabled = str_replace(' ', '', $on_enabled);
    $on_enabled = explode(',', $on_enabled);

    $future = get_post_meta($id, 'appointment_future', true);
    $last_possible_day = null;
    if ((!empty($future)) and ($future != 0)) {
        $last_possible_day = date_i18n('Y-m-d', strtotime('+'.$future.' days'));        
    }

    $days_on_week = get_post_meta($id, 'appointment_days_on_week', true);
    $days_on_week = explode(',', $days_on_week); 

    $type = get_post_meta($id, 'appointment_reservation', true);

    $holidays = explode(',', str_replace(' ', '', $options['holiday']));
    // $works    = explode(',', str_replace(' ', '', $options['work']));    
    // $weekends = explode(',', str_replace(' ', '', $options['free']));

    for ($i = 1; $i <= $days; $i++) {

        $class = array();
        $script = '';
        $d = $i;
        if ($d < 10) { $d = '0'.$d; }
        
        $actual = $month . '-' . $d;
        
        if (date('Y-m-d') == $actual) {
            $class[] = 'now';
        }
        if ($now > $actual) {
            if (!in_array('disabled', $class)) {
                $class[] = 'disabled';
            }
        }
        
        if ((!empty($last_possible_day)) and ($actual > $last_possible_day)) {
            if (!in_array('disabled', $class)) {
                $class[] = 'disabled';
            }
        }


        // Check the holiday
        $is_holiday = false;
        if (in_array($actual, $holidays)) {
            $class[] = 'holiday';
            $is_holiday = true;  
            if ($on_holidays != '1') {
                if (!in_array('disabled', $class)) {
                    $class[] = 'disabled';
                }
            } 
        }
        if ($is_holiday) {
            $end = get_post_meta($id, 'appointment_holiday_off_time', true);
            if (!empty($end)) {
                if (($actual.' '.$end) < $end_time) {
                    $class[] = 'disabled';
                }
            }
        }
        
        // Check the day of week
        $is_day = true;
        $dw = strtolower( date('D', strtotime($actual)) );
        if (!in_array($dw, $days_on_week)) {
            $is_day = false;
        }
        if (!$is_day) {
            if (!in_array('disabled', $class)) {
                $class[] = 'disabled';
            }
        }
        
        // Check the disabled
        if (in_array($actual, $on_disabled)) {
            $class[] = 'disabled';            
        }

        // Check the enabled
        if (in_array($actual, $on_enabled)) {
            if (in_array('disabled', $class)) {
                $class = array_diff($class, 'disabled');
            }
        }

        // Check is Free (or free time count)
        if (!in_array('disabled', $class)) {
            
            if ($type != 'time') {
                $query = 'SELECT COUNT(id) FROM ' . $wpdb->prefix.'bookanappointment ' .
                            'WHERE ' . 
                                '`place_id` = "'.$id.'" AND ' .
                                '`date` = "'.$month.'-'.$d.'"';
                $count = $wpdb->get_var($query);
                if ($count > 0) {
                    $class[] = 'disabled';    
                }
            } else {

                $w = date('W', strtotime($month.'-'.$d));
                if ($w % 2 == 0) {
                    $times_list = $times['couple'];
                } else {
                    $times_list = $times['odd'];
                }
                if (date('Y-m-d') == $month.'-'.$d) {
                    $index_time = date_i18n('H:i');
                    $query = 'SELECT COUNT(id) FROM ' . $wpdb->prefix.'bookanappointment ' .
                                'WHERE ' . 
                                    '`place_id` = "'.$id.'" AND ' .
                                    '`date` = "'.$month.'-'.$d.'" AND ' .
                                    '`time` > "'.$index_time.'"';
                    $now_times = array();
                    foreach ($times_list as $time) {
                        if ($time > $index_time) {
                            $now_times[] = $time;
                        }
                    }
                    $times_list = $now_times;
                } else {
                    $query = 'SELECT COUNT(id) FROM ' . $wpdb->prefix.'bookanappointment ' .
                                'WHERE ' . 
                                    '`place_id` = "'.$id.'" AND ' .
                                    '`date` = "'.$month.'-'.$d.'"';
                }
                $count = $wpdb->get_var($query);
                if ($count >= count($times_list)) {
                    $class[] = 'disabled';    
                }
            }
        }        
        
        if (!in_array('disabled', $class)) {
            $class[] = 'selectable';
            $script = 'onclick="book_an_appointment_961_on_select(jQuery(this))"';
        }

        $day = apply_filters('book_an_appointment_one_day', $class, $script, $month.'-'.$d, $i);
        $html .= $day;
        $col++;

        if ($col > 7) {
            $html .= $week_after.$week_before;
            $col = 1;
        }
    }
    for ($i = $col; $i <= 7; $i++) {
    	$html .= $empty_day;
    }
    
    $html .= $week_after . '</tbody>';

    $mode = get_post_meta($id, 'appointment_reservation', true);

    $prev = date('Y-m', strtotime('-1 month', strtotime($month.'-01')));
    $script = 'onclick="book_an_appointment_961_set_month(jQuery(this), \''.$prev.'\');"';
    $prev_html = apply_filters('book_an_appointment_prev_link', $month, $script, $mode);

    $next_html = '';
    $next = date('Y-m', strtotime('+1 month', strtotime($month.'-01'))).'-01';
    if ((empty($last_possible_day)) or ($next <= $last_possible_day)) {
        $next = date('Y-m', strtotime('+1 month', strtotime($month.'-01')));
        $script = 'onclick="book_an_appointment_961_set_month(jQuery(this), \''.$next.'\');"';
        $next_html = apply_filters('book_an_appointment_next_link', $month, $script);
    }
    
    $html .= apply_filters('book_an_appointment_month_table_footer', $prev_html, $next_html);
    
    $html .= apply_filters('book_an_appointment_month_table_after', null);
    
    return $html;
}

function book_an_appointment_961_render_month() {
    $data = array();
    foreach ($_REQUEST as $key => $value) {
       $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $odd = sanitize_text_field($_REQUEST['odd']);
    $odd = json_decode(html_entity_decode( stripslashes($odd)));

    $couple = sanitize_text_field($_REQUEST['couple']);
    $couple = json_decode(html_entity_decode( stripslashes ($couple)));

    $times = array(
            'odd'    => $odd,
            'couple' => $couple
        );

    $html = book_an_appointment_961_render_month_table($data['now'], $data['id'], $times);

    $result = array(
        'status' => 1,
        'html'   => $html,
        'token'  => $data['token'],
        'now'    => $data['now']
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_render_month', 'book_an_appointment_961_render_month' );
add_action( 'wp_ajax_book_an_appointment_961_render_month', 'book_an_appointment_961_render_month' );


function book_an_appointment_961_draw_month_function() {
    $data = array();
    foreach ($_REQUEST as $key => $value) {
       $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $odd = sanitize_text_field($_REQUEST['odd']);
    $odd = json_decode(html_entity_decode( stripslashes($odd)));

    $couple = sanitize_text_field($_REQUEST['couple']);
    $couple = json_decode(html_entity_decode( stripslashes ($couple)));

    $times = array(
            'odd'    => $odd,
            'couple' => $couple
        );

    $data['show_events'] = 0;
    $html = '';
    
    if (!empty($data['id'])) {
        $type = get_post_meta($data['id'], 'appointment_reservation', true);
        if ($type == 'time') {
            $data['show_events'] = 1;
        }
        $html = book_an_appointment_961_render_month_table($data['now'], $data['id'], $times);
    } else {
        $html = apply_filters('book_an_appointment_961_show_error', __('There is no such reservation place.', 'book-an-appointment'));                                
    }
    
    $result = array(
        'status' => 1,
        'html'   => $html,
        'token'  => $data['token'],
        'now'    => $data['now'],
        'id'     => $data['id'],
        'show_events' => $data['show_events']
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_draw_month_function', 'book_an_appointment_961_draw_month_function' );
add_action( 'wp_ajax_book_an_appointment_961_draw_month_function', 'book_an_appointment_961_draw_month_function' );

function book_an_appointment_961_show_times_function() {

    global $wpdb;

    $day   = sanitize_text_field($_REQUEST['day']);
    $id    = sanitize_text_field($_REQUEST['id']);
    $token = sanitize_text_field($_REQUEST['token']);
    
    $odd = sanitize_text_field($_REQUEST['odd']);
    $odd = json_decode(html_entity_decode( stripslashes($odd)));

    $couple = sanitize_text_field($_REQUEST['couple']);
    $couple = json_decode(html_entity_decode( stripslashes ($couple)));

    $holidays = sanitize_text_field($_REQUEST['holidays']);
    $holidays = json_decode(html_entity_decode( stripslashes ($holidays)));

    $w = date('W', strtotime($day));
    if ($w % 2 == 0) {
        $times = $couple;
    } else {
        $times = $odd;
    }

    $options = book_an_appointment_961_get_options();
    $list_holidays = explode(',', str_replace(' ', '', $options['holiday']));
    $list_works    = explode(',', str_replace(' ', '', $options['work']));    
    $list_weekends = explode(',', str_replace(' ', '', $options['free']));

    // Check the holiday
    if (in_array($day, $list_holidays)) {
        if (!empty($holidays)) {
            $times = $holidays;
        }
    }


    // Check the weekend
    if (in_array($day, $list_weekends)) {
        if (!empty($holidays)) {
            $times = $holidays;
        }
    } else {
        $n = date('N', strtotime($day));
        if ($n > 5) {
            if (!in_array($day, $list_works)) {
                if (!empty($holidays)) {
                    $times = $holidays;
                }
            }
        }            
    }

    $query = 'SELECT `time` FROM ' . $wpdb->prefix.'bookanappointment ' .
                'WHERE ' . 
                    '`place_id` = "'.$id.'" AND ' .
                    '`date` = "'.$day.'"';
    $busy = $wpdb->get_col($query);

    $shift = get_post_meta($id, 'appointment_shift', true);
    $now = date_i18n('Y-m-d H:i', strtotime('+'.$shift.' hours', strtotime(date_i18n('H:i'))));

    $counter = 0; $html = '';
    foreach ($times as $time) {
        if ($now < $day . ' ' . $time) {
            if (!in_array($time, $busy)) {
                $script = 'onclick="book_an_appointment_961_on_select_time(jQuery(this));"';
                $html .= apply_filters('book_an_appointment_one_time', $time, $script, '');
                $counter++;
            } else {
                $html .= apply_filters('book_an_appointment_one_time', $time, '', 'busy');
            }
        } else {
            $html .= apply_filters('book_an_appointment_one_time', $time, '', 'old');
        }
    }
    if ($counter == 0) {
        $html .= apply_filters('book_an_appointment_show_error', __('<strong>Sorry!</strong> There are no more appointments for this day.','book-an-appointment'));
    }

    $result = array(
        'status' => 1,
        'html'   => $html,
        'token'  => $token
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_show_times_function', 'book_an_appointment_961_show_times_function' );
add_action( 'wp_ajax_book_an_appointment_961_show_times_function', 'book_an_appointment_961_show_times_function' );

function book_an_appointment_961_save_appointment_function() {

    global $wpdb;

    $token = sanitize_text_field($_REQUEST['token']);
    $date = json_decode(html_entity_decode( stripslashes( sanitize_text_field($_REQUEST['days']) )));
    
    $options = book_an_appointment_961_get_options();

    if ($options['filter_type'] == 'fruits') {

        $fruitName  = sanitize_text_field($_REQUEST['name']);
        $fruitID    = sanitize_text_field($_REQUEST['fruit']);
        if ($fruitID == 0) { $fruitName = null; } else { $fruitID--; }
        
        $fruits = explode('|', __('apple|banana|blackberry|cherry|orange|pear|plum|raspberry|strawberry|lemon|peach|grapes|apricot|watermelon|coconut|melon|pineapple|kiwi', 'book-an-appointment'));
        if (($fruitName == null) or ($fruitName != $fruits[$fruitID])) {
    
            $html = apply_filters('book_an_appointment_show_error', __('<strong>Error checking robot!</strong> The selected fruit is not suitable.', 'book-an-appointment'));                
    
            $data = array(
                'status' => 0,
                'html'   => $html,
                'time'   => '', 
                'month'  => substr($date[0], 0, 7),
                'token'  => $token
            );
            echo json_encode($data);
            wp_die();
            
        }
        
    }

    if ($options['filter_type'] == 'google') {

        if (isset($_REQUEST['recaptcha']) && !empty($_REQUEST['recaptcha'])) {
            $response = sanitize_text_field($_REQUEST['recaptcha']);
        }
        $verifyResponse = file_get_contents('https://www.google.com/recaptcha/api/siteverify?secret='.$options['google_secret_key'].'&response='.$response);
        $responseData = json_decode($verifyResponse, true);  
        
        if (!$responseData['success']) {
            
            $errors = implode('<br /', $responseData['error-codes']);
            
            $html = apply_filters('book_an_appointment_show_error', __('<strong>Error checking robot!</strong>', 'book-an-appointment').' '.$errors);                
    
            $data = array(
                'status' => 0,
                'html'   => $html,
                'time'   => '', 
                'month'  => substr($date[0], 0, 7),
                'token'  => $token
            );
            echo json_encode($data);
            wp_die();
            
        }  
    }
    
    $id   = sanitize_text_field($_REQUEST['id']);
    $time = '';
    if (isset($_REQUEST['time'])) {
        $time = sanitize_text_field($_REQUEST['time']);
    }
    $data = json_decode(html_entity_decode( stripslashes( sanitize_text_field($_REQUEST['data']) )), true);

    $type = get_post_meta($id, 'appointment_reservation', true);
    $month = '';
    if ($type == 'time') {
        $date = $date[0];

        $query = 'SELECT COUNT(id) AS count FROM ' . $wpdb->prefix.'bookanappointment ' .
                    'WHERE ' . 
                        '`place_id` = "'.$id.'" AND ' .
                        '`date` = "'.$date.'" AND ' .
                        '`time` = "'.$time.':00"';
        $result = $wpdb->get_results($query);
        $count = $result[0]->count;
        if ($count > 0) {
            $status = 0;
            $html = apply_filters('book_an_appointment_show_error', __('<strong>We are sorry!</strong> The date has meanwhile been booked by someone else.', 'book-an-appointment'));
                                        
        } else {

            $url_token = book_an_appointment_961_generate_token();
            $data = apply_filters('book_an_appointment_before_confirmation_mail', $url_token, $data);

            $wpdb->insert($wpdb->prefix.'bookanappointment',
                array(
                    'place_id' => $id,
                    'date'     => $date,
                    'time'     => $time,
                    'ip'       => book_an_appointment_961_get_IP_address(),
                    'token'    => $url_token,
                    'data'     => serialize($data)
                )
            );
            if ($wpdb->last_error != '') {
                $time = '';
                $status = 0;
                $html = apply_filters('book_an_appointment_show_error', htmlspecialchars( $wpdb->last_result, ENT_QUOTES ));                        
                                                                
            } else {
                $status = 1;
                $html = apply_filters('book_an_appointment_show_error', __('<strong>Thank You!</strong> The booking has been recorded and an email has been sent to you to confirm to the address provided.<br /><small>Remember to also check your spam folder!</small>', 'book-an-appointment'));
                $error = book_an_appointment_961_send_mail($id, $date, $time, $data, $url_token, true);
                if ($error != '') {
                    $html = $error;
                } else {

                    if (has_action('book_an_appointment_after_confirmation_mail')) {
                        do_action('book_an_appointment_after_confirmation_mail', $url_token, $data);                    
                    }
                    
                }                       
            }
        }
        
    } else {
        $query = 'SELECT COUNT(id) AS count FROM ' . $wpdb->prefix.'bookanappointment ' .
                    'WHERE ' . 
                        '`place_id` = "'.$id.'" AND ' .
                        '`date` IN ("'.implode('","', $date).'")';
        $result = $wpdb->get_results($query);
        $count = $result[0]->count;

        if ($count > 0) {
            $status = 0;
            $html = apply_filters('book_an_appointment_show_error', __('<strong>We are sorry!</strong> The date has meanwhile been booked by someone else.', 'book-an-appointment'));                    
            $month = substr($date[0], 0, 7);
        } else {

            $url_token = book_an_appointment_961_generate_token();
            $data = apply_filters('book_an_appointment_before_confirmation_mail', $url_token, $data);
            
            $ip = book_an_appointment_961_get_IP_address();
            $errors = array();
            foreach ($date as $item) {
                $wpdb->insert($wpdb->prefix.'bookanappointment',
                    array(
                        'place_id' => $id,
                        'date'     => $item,
                        'ip'       => $ip,
                        'token'    => $url_token,
                        'data'     => serialize($data)
                    )
                );
                if ($wpdb->last_error != '') {
                    $errors[] = apply_filters('book_an_appointment_show_error', htmlspecialchars( $wpdb->last_result, ENT_QUOTES ));                                                                
                }                
            }
            if (!empty($errors)) {
                $html = implode('', $errors);
                $time = '';
                $status = 0;
            } else {
                $status = 1;
                $html = apply_filters('book_an_appointment_show_error', __('<strong>Thank You!</strong> The booking has been recorded and an email has been sent to you to confirm to the address provided.<br /><small>Remember to also check your spam folder!</small>', 'book-an-appointment'));
                $error = book_an_appointment_961_send_mail($id, $date, $time, $data, $url_token, true);
                if ($error != '') {
                    $html = $error;
                } else {

                    if (has_action('book_an_appointment_after_confirmation_mail')) {
                        do_action('book_an_appointment_after_confirmation_mail', $url_token, $data);                    
                    }
                   
                }                       
            }
        }
    }

    $result = array(
        'status' => $status,
        'html'   => $html,
        'time'   => $time,
        'month'  => $month,
        'token'  => $token
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_save_appointment_function', 'book_an_appointment_961_save_appointment_function' );
add_action( 'wp_ajax_book_an_appointment_961_save_appointment_function', 'book_an_appointment_961_save_appointment_function' );

function book_an_appointment_961_generate_token()
{

    $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
    $token = array();
    for ($j = 0; $j <= 4; $j++) {
        $token[$j] = '';
        for ($i = 1; $i <= 4; $i++) {
        	$token[$j] .= substr($chars, rand(0, strlen($chars)-1), 1);
        }                
    }
    $token = implode('-', $token);
    return $token;
}


function book_an_appointment_961_send_mail($post_id, $days, $time, $data, $token, $add_event = false) {
    
    if (isset($data['email'])) {
        
        $headers = array('Content-Type: text/html; charset=UTF-8');
        $subject = __('Booking confirmation', 'book-an-appointment');
        
        $data['link_confirmation'] = get_home_url().'/booking-confirmation/'.$token;
        $data['link_cancel'] = get_home_url().'/booking-cancel/'.$token;
        $data['title'] = get_the_title($post_id);
        
        $data['description'] = book_an_appointment_961_get_excerpt($post_id);
        
        if (!is_array($days)) {
            $data['day'] = date_i18n('Y. F j., l,', strtotime($days));
            $data['time'] = date_i18n('H:i', strtotime($time));
            $data['days'] = '';
        } else {
            $data['day'] = '';
            $data['days'] = array();
            foreach ($days as $day) {
                $data['days'][] = array('day' => date_i18n('Y. F j., l,', strtotime($day)));    
            }
        }
        
        $lang = book_an_appointment_961_get_lang();
        $tmpl = new JDovi42_Templates(BOOK_AN_APPOINTMENT_961_ROOT);
        $tmpl->useTemplate('emails' .DIRECTORY_SEPARATOR. $lang .DIRECTORY_SEPARATOR. 'confirmation-user.html');
        $tmpl->setOptions($data);
        
        $body = $tmpl->prepareContent();
        
        if ($body == '') {
            return '';
        }
        
        if ($add_event) {

            $data['timestamp'] = date_i18n('Ymd') . 'T' . date_i18n('His') . 'Z';
            $offset = get_option('gmt_offset');
            if ($offset > 0) {
                if ($offset < 10) {
                    $offset = '0'.$offset;    
                }
                $offset = '+'.$offset; 
            } 
            if ($offset < 0) {
                if ($offset > -10) {
                    $offset = '0'.$offset;    
                }
                $offset = '-'.$offset;
            }
            $data['time_zone_offset'] = $offset.'00';
            
            if (!is_array($days)) {

                $data['type_time'] = '1';
                $time = strtotime($days . ' '. $time);
                $data['start_time'] = date('Ymd', $time) . 'T' .
                                      date('Hi', $time) .'00';
                $mins = get_post_meta($post_id, 'appointment_mins', true);
                $mins--;
                $time = strtotime('+'.$mins.' minute', $time);
                $data['end_time'] = date('Ymd', $time) . 'T' .
                                    date('Hi', $time) .'00';

            } else {
                $data['type_time'] = '';
                $start = date('Ymd', strtotime($days[0]));
                $data['start_date'] = $start;
                $end = date('Ymd', strtotime('+1 day', strtotime($days[count($days)-1])));
                $data['end_date'] = $end;
            }
    
            $data = apply_filters('book_an_appointment_before_event_generate', $data);
            $data['description'] = strip_tags($data['description']);

            $tmpl = new JDovi42_Templates(BOOK_AN_APPOINTMENT_961_ROOT);
            $tmpl->useTemplate('emails' .DIRECTORY_SEPARATOR. $lang .DIRECTORY_SEPARATOR. 'event.html');
            $tmpl->setOptions($data);

            $ics = $tmpl->prepareContent();
            
            $attachments = BOOK_AN_APPOINTMENT_961_ROOT.DIRECTORY_SEPARATOR.'temp'.DIRECTORY_SEPARATOR.date_i18n('YmdHis').'.ics';
            file_put_contents($attachments, $ics);
            
        } else {
            $attachments = array();
        }
        
        if ( wp_mail($data['email'], $subject, $body, $headers, $attachments) ) {
            $html = '';
        } else {
            $html = apply_filters('book_an_appointment_show_error', __('Error sending email', 'book-an-appointment'));
        }

        if ($add_event != '') {
            unlink($attachments);
        }

        return $html;
    }
    $html = apply_filters('book_an_appointment_show_error', __('No email address set!', 'book-an-appointment'));
    return $html;
}

function book_an_appointment_961_get_IP_address()
{
    foreach (array('HTTP_CLIENT_IP',
                   'HTTP_X_FORWARDED_FOR',
                   'HTTP_X_FORWARDED',
                   'HTTP_X_CLUSTER_CLIENT_IP',
                   'HTTP_FORWARDED_FOR',
                   'HTTP_FORWARDED',
                   'REMOTE_ADDR') as $key){
        if (array_key_exists($key, $_SERVER) === true){
            foreach (explode(',', $_SERVER[$key]) as $IPaddress){
                $IPaddress = trim($IPaddress); // Just to be safe
                if (filter_var($IPaddress,
                               FILTER_VALIDATE_IP,
                               FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)
                    !== false) {

                    return $IPaddress;
                }
            }
            return $IPaddress;
        }
    }
}

function book_an_appointment_961_accept_books() {
    
    global $wpdb;    
    
    $tokens = isset( $_REQUEST['tokens'] ) ? (array) $_REQUEST['tokens'] : array();
    $tokens = array_map( 'esc_attr', $tokens );

    $errors = array();
    $status = 1;

    foreach ($tokens as $token) {

        $sql = 'SELECT *'.
               ' FROM ' . $wpdb->prefix . 'bookanappointment' . 
               ' WHERE `token` = "'.$token.'"' .
               ' ORDER BY `id` DESC';
        $items = $wpdb -> get_results($sql);

        if (empty($items)) {
            $status = 0;
            $errors[] = array(
                            'token'   => $token,
                            'message' => __('Token not found', 'book-an-appointment')
                        ); 
            $tokens = array_diff($tokens, $token);           
        } else {
            $data = unserialize($items[0]->data);
            $email = $data['email'];
            
            if ((isset($email)) and (!empty($email))) {

                $headers = array('Content-Type: text/html; charset=UTF-8');
                $subject = __('Booking accepted confirmation', 'book-an-appointment');
                
                if (!is_array($items)) {
                    $data['day'] = date_i18n('Y. F j., l,', strtotime($items[0]->date));
                    $data['time'] = date_i18n('H:i', strtotime($items[0]->time));
                    $data['days'] = '';
                } else {
                    $data['day'] = '';
                    $data['days'] = array();
                    foreach ($items as $item) {
                        $data['days'][] = array('day' => date_i18n('Y. F j., l,', strtotime($item->date)));    
                    }
                }

                $data['title'] = get_the_title($items[0]->place_id);
                $data['description'] = book_an_appointment_961_get_excerpt($items[0]->place_id);
                $data['link_cancel'] = get_home_url().'/booking-cancel/'.$items[0]->token;


                $lang = book_an_appointment_961_get_lang();
                $tmpl = new JDovi42_Templates(BOOK_AN_APPOINTMENT_961_ROOT);
                $tmpl->useTemplate('emails' .DIRECTORY_SEPARATOR. $lang .DIRECTORY_SEPARATOR. 'accept-admin.html');
                $tmpl->setOptions($data);

                $body = $tmpl->prepareContent();

                if ($body != '') {
                    if ( !wp_mail($email, $subject, $body, $headers) ) {

                        $status = 0;
                        $errors[] = array(
                                        'token'   => $token,
                                        'message' => __('Error sending email', 'book-an-appointment')
                                    ); 
                        $tokens = array_diff($tokens, $token);           
                    } else {
                        $wpdb->update($wpdb->prefix.'bookanappointment',
                                array('accept' => date_i18n('Y-m-d H:i:s')),
                                array('token' => $token) 
                            );
                    }
                }
                
            } else {
                $status = 0;
                $errors[] = array(
                                'token'   => $token,
                                'message' => __('Email not found', 'book-an-appointment')
                            );
                $tokens = array_diff($tokens, $token);            
            }
        }
        
        
    }

    $result = array(
        'status' => $status,
        'tokens' => $tokens,
        'errors' => $errors
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_accept_books', 'book_an_appointment_961_accept_books' );
add_action( 'wp_ajax_book_an_appointment_961_accept_books', 'book_an_appointment_961_accept_books' );

function book_an_appointment_961_delete_books() {
    
    global $wpdb;    
    
    $tokens = isset( $_REQUEST['tokens'] ) ? (array) $_REQUEST['tokens'] : array();
    $tokens = array_map( 'esc_attr', $tokens );

    $message = '';
    if (isset($_REQUEST['message'])) {
        $message = sanitize_text_field($_REQUEST['message']);
    }

    $status = 1;

    foreach ($tokens as $token) {

        $sql = 'SELECT *'.
               ' FROM ' . $wpdb->prefix . 'bookanappointment' . 
               ' WHERE `token` = "'.$token.'"' .
               ' ORDER BY `id` DESC';
        $items = $wpdb -> get_results($sql);
        
        if (!empty($items)) {

            $data = unserialize($items[0]->data);
            $email = $data['email'];
            $data['message'] = $message;
            
            if ((isset($email)) and (!empty($email))) {

                $headers = array('Content-Type: text/html; charset=UTF-8');
                $subject = __('Booking cancellation', 'book-an-appointment');
                
                if (!is_array($items)) {
                    $data['day'] = date_i18n('Y. F j., l,', strtotime($items[0]->date));
                    $data['time'] = date_i18n('H:i', strtotime($items[0]->time));
                    $data['days'] = '';
                } else {
                    $data['day'] = '';
                    $data['days'] = array();
                    foreach ($items as $item) {
                        $data['days'][] = array('day' => date_i18n('Y. F j., l,', strtotime($item->date)));    
                    }
                }

                $data['title'] = get_the_title($items[0]->place_id);
                $data['description'] = book_an_appointment_961_get_excerpt($items[0]->place_id);

                $lang = book_an_appointment_961_get_lang();
                $tmpl = new JDovi42_Templates(BOOK_AN_APPOINTMENT_961_ROOT);
                $tmpl->useTemplate('emails' .DIRECTORY_SEPARATOR. $lang .DIRECTORY_SEPARATOR. 'cancelled-admin.html');
                $tmpl->setOptions($data);
                
                $body = $tmpl->prepareContent();
                if ($body != '') {
                    wp_mail($email, $subject, $body, $headers);
                } 
            }
            
            book_an_appointment_961_remove_google_calendar($token);
            
            $wpdb->delete(
                    $wpdb->prefix.'bookanappointment',
                    array('token' => $token) 
                );
        }

    }

    $result = array(
        'status' => $status,
        'tokens' => $tokens
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_delete_books', 'book_an_appointment_961_delete_books' );
add_action( 'wp_ajax_book_an_appointment_961_delete_books', 'book_an_appointment_961_delete_books' );

function book_an_appointment_961_save_google_keys() {

    $status = 0;

    $site_key = '';
    if (isset($_REQUEST['key'])) {
        $site_key = sanitize_text_field($_REQUEST['key']);
    }

    $secret_key = '';
    if (isset($_REQUEST['secret'])) {
        $secret_key = sanitize_text_field($_REQUEST['secret']);
    }

    $options = book_an_appointment_961_get_options();

    if ((empty($site_key)) or (empty($secret_key))) {
        $options['calendar']['code'] = '';
        $options['calendar']['token'] = '';   
    } else {
        $status = 1;
    }
    $options['calendar']['key'] = $site_key;
    $options['calendar']['secret'] = $secret_key;   
    update_option('book_an_appointment_options', $options);

    $result = array(
        'status'     => $status,
        'site_key'   => $site_key,
        'secret_key' => $secret_key,
        'link'       => urlencode('https://www.googleapis.com/auth/calendar'),
        'redirect'   => urlencode(home_url() . '/booking-calendar')
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_save_google_keys', 'book_an_appointment_961_save_google_keys' );
add_action( 'wp_ajax_book_an_appointment_961_save_google_keys', 'book_an_appointment_961_save_google_keys' );

function book_an_appointment_961_unlink_google() {

    $status = 0;

    $options = book_an_appointment_961_get_options();

    if (!empty($options['calendar']['token'])) {
        if (!class_exists('GoogleCalendarApi')) {
            include_once( BOOK_AN_APPOINTMENT_961_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'google-calendar-api.php');
        }
        $capi = new GoogleCalendarApi();
        $capi->RevokingToken($options['calendar']['token']);
        
        $options['calendar']['code'] = '';
        $options['calendar']['token'] = '';
        $options['calendar']['refresh'] = '';
        $options['calendar']['expires'] = '';
        update_option('book_an_appointment_options', $options);
    }

    $result = array(
        'status'     => 1
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_unlink_google', 'book_an_appointment_961_unlink_google' );
add_action( 'wp_ajax_book_an_appointment_961_unlink_google', 'book_an_appointment_961_unlink_google' );



function book_an_appointment_961_action_save_google() {
    
    global $wpdb;    
    
    $tokens = isset( $_REQUEST['tokens'] ) ? (array) $_REQUEST['tokens'] : array();
    $tokens = array_map( 'esc_attr', $tokens );

    $errors = array();
    $status = 1;
    
    $options = book_an_appointment_961_refresh_calendar_token();

    if (!empty($tokens)) {
        if (!class_exists('GoogleCalendarApi')) {
            include_once( BOOK_AN_APPOINTMENT_961_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'google-calendar-api.php');
        }
        $capi = new GoogleCalendarApi();
        $user_timezone = $capi->GetUserCalendarTimezone($options['calendar']['token']);
    }

    foreach ($tokens as $token) {

        $return = book_an_appointment_961_add_google_calendar($token);
        if (!empty($return)) {
            $status = 0;
            $errors[] = array(
                            'token'   => $token,
                            'message' => __('Token not found', 'book-an-appointment')
                        ); 
            $tokens = array_diff($tokens, $token);           
        }
        
    }

    $result = array(
        'status' => $status,
        'tokens' => $tokens,
        'errors' => $errors
    );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_book_an_appointment_961_action_save_google', 'book_an_appointment_961_action_save_google' );
add_action( 'wp_ajax_book_an_appointment_961_action_save_google', 'book_an_appointment_961_action_save_google' );
