<?php

    global $post, $wpdb;

    $id = 0;
    if (isset($_REQUEST['id'])) {
        $id = absint(intval( sanitize_text_field($_REQUEST['id']) ));   
        if (!is_int($id)) {
            $id = 0;
        } 
    } 

    $args = array(
            'numberposts' => -1,
            'post_type'	  => 'booking-place',
            'orderby'     => 'title',
            'order'       => 'ASC'  
        );
    $source = get_posts($args);
    $places = array();
    foreach ($source as $item) {
        $places[$item->ID] = $item->post_title;
    }

?>
<h1 class="wp-heading-inline">
    <?php echo __('Unaccepted books', 'book-an-appointment');?>
</h1>
<div class="tablenav top">
    <form action="edit.php">
        
        <input type="hidden" name="post_type" value="booking-place" />
        <input type="hidden" name="page" value="awaiting_books" />
    
        <?php if (!empty($places)) : ?>
            <select id="id" name="id" onchange="jQuery(this).closest('form').submit();">
                <option value="0" <?php selected($id, '0');?> ><?php echo __('--== All places ==--', 'book-an-appointment');?></option>
                <?php foreach( $places as $key => $title ) : ?>
                    <option value="<?php echo $key; ?>" <?php selected($id, $key);?>><?php echo $title;?></option>
                <?php endforeach; ?>
            </select>
        <?php else: ?>
            <?php echo __('There are no places to display.', 'book-an-appointment');?>
            <a href="/wp-admin/edit.php?post_type=booking-place"><?php echo __('Be the first to create places by clicking here.', 'book-an-appointment');?></a>
        <?php endif; ?>
    
    </form>
</div>
<?php if (!empty($places)) : ?>

    <?php
        $where = array();
        if ($id != 0) {
            $where[] = '`place_id` = "'.$id.'"';
        }
        $where[] = '`confirm` <> ""';
        $where[] = '`accept` = ""';
        $where[] = '`date` >= "'.date_i18n('Y-m-d').'"';
        $where = implode(' AND ', $where);

        $sql = 'SELECT *'.
               ' FROM ' . $wpdb->prefix . 'bookanappointment' . 
               ' WHERE '.$where.
               ' ORDER BY `id` DESC';
        $items = $wpdb -> get_results($sql);
       
        $tokens = array();
        foreach ($items as $item) {
            if (!in_array($item->token, $tokens)) {
                $tokens[] = $item->token;
            }
        }     
        $books = array();
        foreach ($tokens as $token) {
            $data     = null;
            $times    = array();
            $confirm  = null;
            $place_id = null;

            foreach ($items as $item) {
                if ($item->token == $token) {
                    if (empty($data)) {
                        $data = $item->data;
                        $times[] = array('date' => $item->date, 'time' => $item->time);
                        $confirm = $item->confirm;
                        $place_id = $item->place_id;
                    } else {
                        $times[] = array('date' => $item->date, 'time' => $item->time);
                    }
                }
            }
            $books[] = array(
                            'token'    => $token,
                            'place_id' => $place_id,
                            'times'    => $times,
                            'confirm'  => $confirm,
                            'data'     => $data
                         );
        }
           
        ?>
        <div style="margin-right: 20px;"> 
        <table id="unaccepted_bookings" class="wp-list-table widefat fixed striped table-view-list posts">
            <thead>
                <tr>
                    <td id="cb" class="manage-column column-cb check-column">
                        <label class="screen-reader-text" for="cb-select-all-1">Összes kiválasztása</label>
                        <input id="select_all_books" onchange="book_an_appointment_961_toggleAll()" type="checkbox" />
                    </td>
                    <th scope="col" class="manage-column column-title column-primary">
                        <?php echo __('Place name', 'book-an-appointment');?>
                    </th>
                    <th scope="col" class="manage-column column-times column-primary">
                        <?php echo __('Book times', 'book-an-appointment');?>
                    </th>
                    <th scope="col" class="manage-column column-user column-primary">
                        <?php echo __('Booking user', 'book-an-appointment');?>
                    </th>
                    <th scope="col" class="manage-column column-confirmed column-primary">
                        <?php echo __('Booking confirmed', 'book-an-appointment');?>
                    </th>
                    <th scope="col" class="manage-column column-accept column-primary">
                    </th>
                </tr>
            </thead>
            <tbody>
            <?php 
            
                if (empty($books)) {
                    echo '<tr><td colspan="6">'.
                         __('There are no reservations for this place to be confirmed at a later date.', 'book-an-appointment').
                         '</td></tr>';
                }
            
                $date_format = get_option('date_format');
                $time_format = get_option('time_format');                

                foreach ($books as $book) {
                    echo '<tr data-token="'.$book['token'].'">' . 
                             '<td>'.
                                '<input type="checkbox" class="booking_checkbox" value="'.$book['token'].'">' .
                             '</td>' .
                             '<td>'.$places[$book['place_id']].'</td>' .
                             '<td>';
                    $times = array();
                    foreach ($book['times'] as $time) {
                        $t = date_i18n($date_format , strtotime($time['date']));
                        if ($time['time'] != '00:00') {
                            $t .= ' ' . date_i18n($time_format , strtotime($time['time']));;
                        }
                        $times[] = $t;
                    }
                    $user = apply_filters('book_an_appointment_961_booking_content', $book['data']);
                    echo     implode('<br />', $times).'</td>' .
                             '<td>'.$user.'</td>' .
                             '<td>'.date_i18n($date_format . ' ' . $time_format, strtotime($book['confirm'])).'</td>' .
                             '<td class="accept_function">'.
                                '<button onclick="book_an_appointment_961_accept_book(jQuery(this), \''.$book['token'].'\');" type="button" class="button action">'. __('Accept', 'book-an-appointment') .'</button>&nbsp;'.
                                '<button onclick="book_an_appointment_961_delete_book(jQuery(this), \''.$book['token'].'\');" type="button" class="button action">'. __('Delete', 'book-an-appointment') .'</button>'.
                             '</td>' .
                         '</tr>';
                            
                }
            ?>
            </tbody>
            <tfoot>
                <tr>
                    <td colspan="6">
                        <button onclick="book_an_appointment_961_selected_tokens();" id="accept_selected_books" type="button" class="button action" disabled="disabled"><?php echo __('Accept selected', 'book-an-appointment');?></button>
                        <button onclick="book_an_appointment_961_delete_selected_tokens();" id="delete_selected_books" type="button" class="button action" disabled="disabled"><?php echo __('Delete selected', 'book-an-appointment');?></button>
                    </td>
                </tr>
            </tfoot>
        </table>
        </div>
        <div id="books_messageBox" class="books_messageBox" style="display:none;">
            <label for="book_resignation_description"><?php echo __('Resignation message:', 'book-an-appointment');?></label><br />
            <textarea id="book_resignation_description" name="book_resignation_description" style="width:300px;"></textarea>
            <input type="hidden" id="book_resignation_token" name="book_resignation_token" value="" />
            <div style="text-align:center"> 
                <button onclick="book_an_appointment_961_action_delete();" class="button button-primary"><?php echo __('Resignation', 'book-an-appointment');?></button>&nbsp;
                <button onclick="book_an_appointment_961_action_cancel();" class="button"><?php echo __('Cancel', 'book-an-appointment');?></button>
            </div>
        </div>
        <div style="clear: both;"></div>
        
<?php endif; ?>
    