<?php 

    global $wpdb;
    
    $step  = get_post_meta($id, 'appointment_mins', true);
    

    if ((isset($_REQUEST['date'])) || (!empty($_REQUEST['date']))) {
        $week = sanitize_text_field($_REQUEST['date']);
        $stamp = strtotime($week);
        if (is_numeric($stamp)){  
            $m = date( 'm', $stamp ); 
            $d = date( 'd', $stamp ); 
            $y = date( 'Y', $stamp ); 
            if (!checkdate($m, $d, $y)) {
                $week = date('Y-m-d'); 
            } else {
                $week = date('Y-m-d', strtotime($y.'-'.$m.'-'.$d));
            }; 
        } else {
            $week = date('Y-m-d');
        }         
    } else {
        $week = date('Y-m-d');
    }

    $options = book_an_appointment_961_get_options();
    $holidays = array();
    if (!empty($options['holiday'])) {
        $holidays = explode(',', str_replace(' ', '', $options['holiday'])); 
    }
    $works = array();
    if (!empty($options['work'])) {
        $works    = explode(',', str_replace(' ', '', $options['work']));
    }    
    $weekends = array();
    if (!empty($options['free'])) {
        $weekends = explode(',', str_replace(' ', '', $options['free']));
    }
    $disabled = explode(',', str_replace(' ', '', get_post_meta($id, 'appointment_disabled', true)));

    // Prev link
    $prev_week = date('Y-m-d', strtotime('-1 week', strtotime($week))); 
    $inputs[] = '<button type="button" class="setWeek button" data-value="'.$prev_week.'">' .
                    '<span class="dashicons dashicons-arrow-left-alt2"></span>' .
                    '<span>'.date_i18n('W', strtotime($prev_week)).'. '.__('week', 'book-an-appointment').'</span>'.
                '</button>';
    
    // Date selector
    $inputs[] = '<input type="date" name="date" id="browse_books_date" value="'.$week.'" onchange="jQuery(this).closest(\'form\').submit();" />';    

    // Next link
    $next_week = date('Y-m-d', strtotime('+1 week', strtotime($week))); 
    $inputs[] = '<button type="button" class="setWeek button" data-value="'.$next_week.'">' .
                    '<span>'.date_i18n('W', strtotime($next_week)).'. '.__('week', 'book-an-appointment').'</span>'.
                    '<span class="dashicons dashicons-arrow-right-alt2"></span>' .
                '</button>';
                
?>
<div class="tablenav top">
    <div class="booking-browse-navigation">
        <form action="edit.php">
        <?php echo implode("\r\n", $inputs);?>
        </form>
    </div>
</div>
<div style="padding-top: 20px;margin-right: 20px;">
    <table class="booking-table" cellspacing="0" cellpadding="0" border="0">
        <thead>
            <tr>
                <th class="booking-time"></th>
                <?php 
                    $days = array();
                    $start_of_week = get_option( 'start_of_week' );
                    $now = date('N', strtotime($week));
                    $date = strtotime('-'.($now - $start_of_week).' day', strtotime($week));
                    
                    for ($i = 1; $i <= 7; $i++) {
    
                        $actual = date_i18n('Y-m-d', $date);
    
                        $class = array();
                        if (in_array($actual, $disabled)) {
                            $class[] = 'booking-reserved';    
                        }
        
                        // Check the holiday
                        if (in_array($actual, $holidays)) {
                            $class[] = 'holiday';  
                        }
    
                        // Check the weekend
                        $is_weekend = false;
                        if (in_array($actual, $weekends)) {
                            $is_weekend = true;
                        } else {
                            $n = date('N', strtotime($actual));
                            if ($n > 5) {
                                if (!in_array($actual, $works)) {
                                    $is_weekend = true;
                                }
                            }            
                        }
                        if ($is_weekend) {
                            $class[] = 'weekend';   
                        }
                        
                        // Check the business day
                        $is_business = false;
                        if (in_array($actual, $works)) {
                            $is_business = true;
                        } else {
                            $n = date('N', strtotime($actual));
                            if ($n <= 5) {
                                if (!in_array($actual, $weekends)) {
                                    if (!in_array($actual, $holidays)) {
                                        $is_business = true;
                                    }
                                }
                            }            
                        }
                        if ($is_business) {
                            $class[] = 'work';
                        }
    
                    	$days[date_i18n('Y-m-d', $date)] = array();
                        echo '<th class="'.implode(' ', $class).'">'.date_i18n('F j.', $date).'<br /><strong>'.date_i18n('l', $date).'</strong></th>';
                        $date = strtotime('+1 day', $date);
                    }
                ?>
            </tr>
        </thead>
        <?php
            $times = array();
            $reserved = explode(',', str_replace(' ', '', get_post_meta($id, 'appointment_reserved', true)));
    
            $w = date('W', strtotime($week));
            if ($w % 2 == 0) {
                $start = get_post_meta($id, 'appointment_couple_on_time', true);
                $end   = get_post_meta($id, 'appointment_couple_off_time', true);
            } else {
                $start = get_post_meta($id, 'appointment_odd_on_time', true);
                $end   = get_post_meta($id, 'appointment_odd_off_time', true);
            }
            $times[] = $start;
            while ($start < $end) {
                $start = date('H:i', strtotime('+'.$step.' mins', strtotime($start.':00')));
                $times[] = $start;
            }
        ?>
        <tbody>
        <?php
            foreach ($days as $key => $value) {
                $query = 'SELECT `time`, `token`, `data`, `confirm`, `accept` FROM ' . $wpdb->prefix.'bookanappointment ' .
                            'WHERE ' . 
                                '`place_id` = "'.$id.'" AND ' .
                                '`date` = "'.$key.'"';
                $result = $wpdb->get_results($query, ARRAY_A);
                $items = array();
                if (!empty($result)) {
                    foreach ($result as $item) {
                        $items[$item['time']] = $item;
                    }
                }
                $days[$key] = $items;
            }
            
            foreach ($times as $time) {
                echo '<tr>';
                if ($type == 'time') {
                    echo '<td class="booking-time">'.$time.'</td>';
                }
                foreach ($days as $day => $value) {
                    $content = '';
                    $class = array('books-item');
                    if (isset($value[$time])) {
                        $content = apply_filters('book_an_appointment_961_booking_content', $value[$time]['data']);
                        
                        $icons = array();
                        
                        if (!empty($value[$time]['accept'])) {
                            $class[] = 'booking-accepted';
                            $icons[] = '<span onclick="book_an_appointment_961_action_show_delete_box(jQuery(this),\''.$value[$time]['token'].'\')" class="booking-action dashicons dashicons-trash"></span>'; 
                        } else {
                            if (!empty($value[$time]['confirm'])) {
                                $class[] = 'booking-confirmed';
                                $icons[] = '<span onclick="book_an_appointment_961_action_accept(jQuery(this), \''.$value[$time]['token'].'\')" class="booking-action dashicons dashicons-saved"></span>';
                                $icons[] = '<span onclick="book_an_appointment_961_action_show_delete_box(jQuery(this),\''.$value[$time]['token'].'\')" class="booking-action dashicons dashicons-trash"></span>';
                            } else {
                                $class[] = 'booking-pending';
                            }                                            
                        }
                        unset($days[$day][$time]);
                        if (!empty($icons)) {
                            $content .= '<hr />' .
                                        '<div style="text-align:right;">'. implode('', $icons).'</div>';
                        }
                        $content = '<div class="bg-white" data-token="'.$value[$time]['token'].'">'.
                                   '<div class="'.implode(' ', $class).'" >'.$content.'</div>'.
                                   '</div>';
                    }
                    $td_class = array('booking-content');
                    if (in_array($time, $reserved)) {
                        $td_class[] = 'booking-reserved';    
                    }
                    echo '<td class="'.implode(' ', $td_class).'">'.$content.'</td>';
                }
                echo '</tr>';
            }
            echo '</tbody>';
    
            // Időkereten kívüli foglalások létének ellenőrzése
            $is_outtime = false;
            foreach ($days as $day) {
                if (!empty($day)) {
                    $is_outtime = true;
                }
            }
    
            // Ha van időntúli, akkor megjelenítjük
            if ($is_outtime) {
    
                echo '<tfoot><tr>';
                if ($type == 'time') {
                    echo '<td class="booking-time">'.__('Outtime booking', 'book-an-appointment').'</td>';
                }
                foreach ($days as $day => $value) {
                    $content = array();
                    
                    if (!empty($value)) {
                    
                        foreach ($value as $item) {
                    
                            $class = array('books-item');
                            $icons = array();
                            
                            $temp = apply_filters('book_an_appointment_961_booking_content', $item['data']);
                            if (!empty($item['accept'])) {
                                $class[] = 'booking-accepted';
                                $icons[] = '<span onclick="book_an_appointment_961_action_show_delete_box(jQuery(this),\''.$item['token'].'\')" class="booking-action dashicons dashicons-trash"></span>'; 
                            } else {
                                if (!empty($item['confirm'])) {
                                    $class[] = 'booking-confirmed';
                                    $icons[] = '<span onclick="book_an_appointment_961_action_accept(jQuery(this), \''.$item['token'].'\')" class="booking-action dashicons dashicons-saved"></span>';
                                    $icons[] = '<span onclick="book_an_appointment_961_action_show_delete_box(jQuery(this),\''.$item['token'].'\')" class="booking-action dashicons dashicons-trash"></span>';
                                } else {
                                    $class[] = 'booking-pending';
                                }                                            
                            }
    
                            if (!empty($icons)) {
                                $temp .= '<hr />' .
                                         '<div style="text-align:right;">'. implode('', $icons).'</div>';
                            }
                            
                            $content[] =  '<div class="bg-white" data-token="'.$item['token'].'">'.
                                          '<div class="'.implode(' ', $class).'" >'.
                                          '<div class="small"><strong>'.$item['time'].'</strong></div>'.
                                          $temp.
                                          '</div></div>';
                        }
                    }
        
        
                    $td_class = array('booking-content');
                    echo '<td class="booking-content booking-content-outtime">'.implode("\r\n", $content).'</td>';
                }
                echo '</tr></tfoot>';
            }
        ?>
    </table>
</div>    
