<?php

require_once( dirname(__file__) . '/inputs-class.php' );

if ( ! class_exists( 'Dovi42_Meta_Box_Input_UserList') ) :

    class Dovi42_Meta_Box_Input_UserList extends Dovi42_Meta_Box_Inputs  {

        var $options = array(
                'values' => array()
            );

        public function __construct($options)
        {
            parent::__construct($options);
        }

        function render($post_id) {
            
            parent::render($post_id);

            $this->options['values'] = array('not-selected' => __('--== Not selected ==--', 'book-an-appointment'));
            
            $users = get_users(array(
                'orderby' => 'display_name',
                'order' => 'ASC'
            ) );
            foreach ($users as $user) {
                $this->options['values'][$user->ID] = $user->display_name; 
            } 

            if (empty($this->value)) {
                $this->value = 'not-selected';
            }

            $html = '<tr>' . "\r\n" . 
                    "\t" . '<td>' . "\r\n" . 
                    "\t\t" . '<label>'.$this->options['label'].'</label>' . "\r\n" . 
                    "\t" . '</td>' . "\r\n" .
                    "\t" . '<td>' . "\r\n". 
                    "\t\t" . '<select name="'.$this->options['meta_key'].'_'.$this->options['id'].'" data-type="select">' . "\r\n";
            foreach ($this->options['values'] as $key => $value ) {
                $selected = '';
                if ($key == $this->value) { 
                    $selected = 'selected="selected"'; 
                }
                $html .= "\t\t\t" . '<option value="'.$key.'" '.$selected.'>'.$value.'</option>' . "\r\n";
            }               
            $html .= "\t\t" . '</select>' . "\r\n";       
            if ((isset($this->options['description'])) and (!empty($this->options['description']))) {
                    $html .= "\t\t" . '<div class="description small">'.$this->options['description'].'</div>' . "\r\n";
            } 
            
            $html .= "\t" . '</td>' . "\r\n" .
                     '</tr>' . "\r\n"; 
            return $html;
        }

    }
endif;