<?php

function book_an_appointment_961_declarate_appointment_place_cpt() {

	$labels = array(
		'name'                  => _x( 'Appointment places', 'Post Type General Name', 'book-an-appointment' ),
		'singular_name'         => _x( 'Appointment place', 'Post Type Singular Name', 'book-an-appointment' ),
		'menu_name'             => __( 'Places', 'book-an-appointment' ),
		'name_admin_bar'        => __( 'Appointment places', 'book-an-appointment' ),
		'parent_item_colon'     => __( 'Parent Item:', 'book-an-appointment' ),
		'all_items'             => __( 'All places', 'book-an-appointment' ),
		'add_new_item'          => __( 'Add New place', 'book-an-appointment' ),
		'new_item'              => __( 'New place', 'book-an-appointment' ),
		'edit_item'             => __( 'Edit place', 'book-an-appointment' ),
		'item title'            => __( 'Edit title', 'book-an-appointment' ),
		'update_item'           => __( 'Update place', 'book-an-appointment' ),
	);
	$rewrite = array(
		'slug'                  => 'booking-place',
		'with_front'            => true,
		'pages'                 => true,
		'feeds'                 => true,
	);

    $exclude_from_search = true;
	$options = book_an_appointment_961_get_options();
    if ($options['hide'] == 0) {
        $exclude_from_search = false;
    }
    
    $args = array(
		'label'                 => __( 'Places', 'book-an-appointment' ),
		'description'           => __( 'Book an appointment using several possible locations.', 'book-an-appointment' ),
		'labels'                => $labels,
		'supports'              => array( 'title', 'editor', 'thumbnail'),
		'taxonomies'            => array( 'category'),
		'hierarchical'          => false,
		'public'                => true,
		'show_ui'               => true,
		'show_in_menu'          => true,
		'menu_position'         => 5,
		'menu_icon'             => 'dashicons-location-alt',
		'show_in_admin_bar'     => false,
		'show_in_nav_menus'     => false,
		'can_export'            => true,
		'has_archive'           => true,
		'exclude_from_search'   => $exclude_from_search,
		'publicly_queryable'    => true,
		'rewrite'               => $rewrite,
		'capability_type'       => 'post',
		'show_in_rest'          => true,
		'rest_base'             => 'booking-place',
	);
	register_post_type( 'booking-place', $args );
    
}
add_action( 'init', 'book_an_appointment_961_declarate_appointment_place_cpt', 0 );

function book_an_appointment_961_new_title( $title ) {

	$screen = get_current_screen()->post_type;
    if ($screen == 'booking-place') {
        $title = __('Appointment places', 'book-an-appointment');
    }
	return $title;
}
add_filter( 'enter_title_here', 'book_an_appointment_961_new_title' );


function book_an_appointment_961_styles_and_scripts_to_admin_frontend()
{
    global $pagenow;

    wp_register_style( 'book-an-appointment-frontend-admin', plugins_url( 'book-an-appointment/assets/css/book-an-appointment-frontend-admin.css', BOOK_AN_APPOINTMENT_961_ROOT ) );
	wp_enqueue_style( 'book-an-appointment-frontend-admin' );

	wp_register_script('book-an-appointment-frontend-admin-js', plugins_url( 'book-an-appointment/assets/js/book-an-appointment-frontend-admin.js', BOOK_AN_APPOINTMENT_961_ROOT ), array('jquery'), false, true);

	wp_localize_script('book-an-appointment-frontend-admin-js', 'book_an_appointment_961_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
	wp_enqueue_script('book-an-appointment-frontend-admin-js');
}

function book_an_appointment_961_add_message_box() {
    ?>
        <div id="books_messageBox" class="books_messageBox" style="display:none;">
            <label for="book_resignation_description"><?php echo __('Resignation message:', 'book-an-appointment');?></label><br />
            <textarea id="book_resignation_description" name="book_resignation_description" style="width:300px;"></textarea>
            <input type="hidden" id="book_resignation_token" name="book_resignation_token" value="" />
            <div style="text-align:center;margin-top:10px;"> 
                <button onclick="book_an_appointment_961_action_delete();" class="button button-primary"><?php echo __('Resignation', 'book-an-appointment');?></button>&nbsp;
                <button onclick="book_an_appointment_961_action_cancel();" class="button button-secondary"><?php echo __('Cancel', 'book-an-appointment');?></button>
            </div>
        </div>
        <div style="clear: both;"></div>
    <?php
}

// Custom post type template
function book_an_appointment_961_load_custom_post_template($template) {
    global $post;

    if ($post->post_type === 'booking-place') {
        
        $managed = false;
        
        $user = wp_get_current_user();

        if ($user->ID != 0) {

            $managers = get_post_meta($post->ID, 'appointment_managers', true);
            if (empty($managers)) { 
                $managers = array(); 
            } else {
                $managers = explode(',', $managers);
            }
    
            $roles = ( array ) $user->roles;        
            
            foreach ($roles as $role) {
                if (in_array($role, $managers)) {
                    $managed = true;
                }
            }

            $manager = get_post_meta($post->ID, 'appointment_manager', true);
    
            if ($user->ID == $manager) {
                $managed = true;
            }
            
        }
        
        if ($managed) {
            if (locate_template( array( 'single-booking-place-admin.php' ) ) !== $template) {
                add_action( 'wp_enqueue_scripts', 'book_an_appointment_961_styles_and_scripts_to_admin_frontend' );
                add_action( 'get_footer', 'book_an_appointment_961_add_message_box', 1);
                return plugin_dir_path( dirname(__FILE__ )) . 'templates' .DS. 'single-booking-place-admin.php'; 
           }  
        } else {
            if (locate_template( array( 'single-booking-place.php' ) ) !== $template) {
                return plugin_dir_path( dirname(__FILE__ )) . 'templates' .DS. 'single-booking-place.php'; 
           }  
        }
    } 
    return $template;
}
add_filter( 'single_template', 'book_an_appointment_961_load_custom_post_template' );
