<?php
    if (isset($_REQUEST['date'])) {
        $week = sanitize_text_field($_REQUEST['date']);
        $stamp = strtotime($week);
        if (is_numeric($stamp)){  
            $m = date( 'm', $stamp ); 
            $d = date( 'd', $stamp ); 
            $y = date( 'Y', $stamp ); 
            if (!checkdate($m, $d, $y)) {
                $week = date('Y-m-d'); 
            } else {
                $week = date('Y-m-d', strtotime($y.'-'.$m.'-'.$d));
            }; 
        } else {
            $week = date('Y-m-d');
        }         
    } else {
        $week = date('Y-m-d');
    }

    $options = book_an_appointment_961_get_options();
    $holidays = explode(',', str_replace(' ', '', $options['holiday']));
    // $works    = explode(',', str_replace(' ', '', $options['work']));    
    // $weekends = explode(',', str_replace(' ', '', $options['free']));
    $works = array();
    $weekends = array();
    $disabled = explode(',', str_replace(' ', '', get_post_meta($post_id, 'appointment_disabled', true)));
?>
<h1 class="title"><?php the_title()?> :: <?php echo '<span style="text-transform:capitalize">'.date_i18n('Y. F', strtotime($week)).'</span>, '.date_i18n('W', strtotime($week)).'. '.__('week', 'book-an-appointment').'</span>';?></h1>
<div class="week">

    <table style="width: 100%;margin-bottom:10px;" border="0">
        <tr>
            <td style="width: 50%; text-align:left">
                <?php 
                    $nav_week = date('Y-m-d', strtotime('-1 week', strtotime($week))); 
                    $link = get_permalink() . '?date=' . $nav_week; 
                ?>
                <a class="btn btn-primary" href="<?php echo $link;?>">
                    <span class="dashicons dashicons-arrow-left-alt2" style="margin-top: 3px;"></span>
                    <span><?php echo date_i18n('W', strtotime($nav_week));?>. <?php echo __('week', 'book-an-appointment');?></span>
                </a>
            </td>        
            <td style="width: 50%; text-align:right">
                <?php 
                    $nav_week = date('Y-m-d', strtotime('+1 week', strtotime($week))); 
                    $link = get_permalink() . '?date=' . $nav_week; 
                ?>
                <a class="btn btn-primary" href="<?php echo $link;?>">
                    <span><?php echo date_i18n('W', strtotime($nav_week));?>. <?php echo __('week', 'book-an-appointment');?></span>
                    <span class="dashicons dashicons-arrow-right-alt2" style="margin-top: 3px;"></span>
                </a>
            </td>        
        </tr>
    </table>

    <table class="booking-table">
        <thead>
            <tr>
                <th class="booking-time"></th>
                <?php 
                    $days = array();
                    $start_of_week = get_option( 'start_of_week' );
                    $now = date('N', strtotime($week));
                    $date = strtotime('-'.($now - $start_of_week).' day', strtotime($week));
                    
                    for ($i = 1; $i <= 7; $i++) {

                        $actual = date_i18n('Y-m-d', $date);

                        $class = array();
                        if (in_array($actual, $disabled)) {
                            $class[] = 'booking-reserved';    
                        }
        
                        // Check the holiday
                        if (in_array($actual, $holidays)) {
                            $class[] = 'holiday';  
                        }

                        // Check the weekend
                        $is_weekend = false;
                        if (in_array($actual, $weekends)) {
                            $is_weekend = true;
                        } else {
                            $n = date('N', strtotime($actual));
                            if ($n > 5) {
                                if (!in_array($actual, $works)) {
                                    $is_weekend = true;
                                }
                            }            
                        }
                        if ($is_weekend) {
                            $class[] = 'weekend';   
                        }
                        
                        // Check the business day
                        $is_business = false;
                        if (in_array($actual, $works)) {
                            $is_business = true;
                        } else {
                            $n = date('N', strtotime($actual));
                            if ($n <= 5) {
                                if (!in_array($actual, $weekends)) {
                                    if (!in_array($actual, $holidays)) {
                                        $is_business = true;
                                    }
                                }
                            }            
                        }
                        if ($is_business) {
                            $class[] = 'work';
                        }

                    	$days[date_i18n('Y-m-d', $date)] = array();
                        echo '<th class="'.implode(' ', $class).'">'.date_i18n('F j.', $date).'<br /><strong>'.date_i18n('l', $date).'</strong></th>';
                        $date = strtotime('+1 day', $date);
                    }
                ?>
            </tr>
        </thead>
        <?php
            $times = array();
            $reserved = explode(',', str_replace(' ', '', get_post_meta($post_id, 'appointment_reserved', true)));
            $times = array();

            $w = date('W', strtotime($week));
            if ($w % 2 == 0) {
                $start = get_post_meta($post_id, 'appointment_couple_on_time', true);
                $end   = get_post_meta($post_id, 'appointment_couple_off_time', true);
            } else {
                $start = get_post_meta($post_id, 'appointment_odd_on_time', true);
                $end   = get_post_meta($post_id, 'appointment_odd_off_time', true);
            }
            $times[] = $start;
            while ($start < $end) {
                $start = date('H:i', strtotime('+'.$step.' mins', strtotime($start.':00')));
                $times[] = $start;
            }
        ?>
        <tbody>
        <?php
            foreach ($days as $key => $value) {
                $query = 'SELECT `time`, `data`, `confirm`, `accept`, `token` FROM ' . $wpdb->prefix.'bookanappointment ' .
                            'WHERE ' . 
                                '`place_id` = "'.$post_id.'" AND ' .
                                '`date` = "'.$key.'"';
                $result = $wpdb->get_results($query, ARRAY_A);
                $items = array();
                if (!empty($result)) {
                    foreach ($result as $item) {
                        $items[$item['time']] = $item;
                    }
                }
                $days[$key] = $items;
            }
            
            foreach ($times as $time) {
                echo '<tr>';
                if ($type == 'time') {
                    echo '<td class="booking-time">'.$time.'</td>';
                }
                foreach ($days as $day => $value) {
                    $content = '';
                    $class = array();
                    $icons = array();
                    
                    if (isset($value[$time])) {
                        $content = apply_filters('book_an_appointment_961_booking_content', $value[$time]['data']);
                        if (!empty($value[$time]['accept'])) {
                            $class[] = 'booking-accepted';
                            $icons[] = '<span data-token="'.$value[$time]['token'].'" class="book_an_appointment_961_action_show_delete_box booking-action dashicons dashicons-trash"></span>';
                        } else {
                            if (!empty($value[$time]['confirm'])) {
                                $class[] = 'booking-confirmed';
                                $icons[] = '<span data-token="'.$value[$time]['token'].'" class="book_an_appointment_961_action_accept booking-action dashicons dashicons-saved"></span>';
                                $icons[] = '<span data-token="'.$value[$time]['token'].'" class="book_an_appointment_961_action_show_delete_box booking-action dashicons dashicons-trash"></span>';
                            } else {
                                $class[] = 'booking-pending';
                            }                                            
                        }
                        unset($days[$day][$time]);
                        
                        if (!empty($icons)) {
                            $content .= '<div class="booking-admin-icons" style="display:none;">'.
                                        '<hr style="margin: 4px 0;" />' .
                                        '<div style="text-align:right;">'. implode('', $icons).'</div></div>';
                        }

                        $content = '<div class="bg-white" data-token="'.$value[$time]['token'].'">'.
                                   '<div class="books-item '.implode(' ', $class).'">'.$content.'</div></div>';
                        
                    } else {
                        $content = '';
                    }
                    $td_class = array('booking-content');
                    if (in_array($time, $reserved)) {
                        $td_class[] = 'booking-reserved';    
                    }
                    
                    echo '<td class="'.implode(' ', $td_class).'">'.
                         $content.
                         '</td>';
                }
                echo '</tr>';
            }
        ?>
        </tbody>
        
<?php
        // Időkereten kívüli foglalások létének ellenőrzése
        $is_outtime = false;
        foreach ($days as $day) {
            if (!empty($day)) {
                $is_outtime = true;
            }
        }

        // Ha van időntúli, akkor megjelenítjük
        if ($is_outtime) {

            echo '<tfoot><tr>';
            if ($type == 'time') {
                echo '<td class="booking-time">'.__('Outtime booking', 'book-an-appointment').'</td>';
            }
            foreach ($days as $day => $value) {
                $content = array();
                
                if (!empty($value)) {
                
                    foreach ($value as $item) {
                
                        $class = array();
                        
                        $temp = apply_filters('book_an_appointment_961_booking_content', $item['data']);
                        if (!empty($item['accept'])) {
                            $class[] = 'booking-accepted';
                        } else {
                            if (!empty($item['confirm'])) {
                                $class[] = 'booking-confirmed';
                            } else {
                                $class[] = 'booking-pending';
                            }                                            
                        }
                        
                        $content[] =  '<div class="'.implode(' ', $class).'">'.
                                      '<div class="small"><strong>'.$item['time'].'</strong></div>'.
                                      $temp.
                                      '</div>';
                    }
                }
    
    
                $td_class = array('booking-content');
                echo '<td class="booking-content booking-content-outtime">'.implode("\r\n", $content).'</td>';
            }
            echo '</tr></tfoot>';
        }


?>
    </table>
</div>


